/*********************************************************************
	Rhapsody	: 7.1
	Login		: ysong_a
	Component	: DelayReqRespMaster
	Configuration 	: MasterClock
	Model Element	: MasterClock
//!	Generated Date	: Tue, 29, Jul 2008 
	File Path	: DelayReqRespMaster/MasterClock/DelayReqRespMaster/MasterClock.java
*********************************************************************/

package DelayReqRespMaster;

//## auto_generated
import java.io.*;
//## auto_generated
import java.net.*;
//## auto_generated
import java.text.*;
//## auto_generated
import java.util.*;
//## auto_generated
import java.lang.*;
//## auto_generated
import java.util.*;
//## auto_generated
import PTPDevices.*;
//## auto_generated
import PTPMessages.*;
//## auto_generated
import PTPDataSets.*;
//## auto_generated
import PTPEntities.*;
//## auto_generated
import PTPEnumTypes.*;
//## attribute sync 
import PTPMessages.Sync;
//## auto_generated
import java.lang.Runnable;
//## auto_generated
import java.net.InetAddress;
//## auto_generated
import PTPDerivedDataTypes.*;
//## attribute followUp 
import PTPMessages.Follow_Up;
//## attribute delayResp 
import PTPMessages.Delay_Resp;
//## class MasterClock 
import PTPDevices.OrdinaryClock;
//## auto_generated
import PTPPrimitivityDataTypes.*;
//## auto_generated
import com.ilogix.rhapsody.oxf.*;
//## attribute followUpTimestamp 
import PTPDerivedDataTypes.Timestamp;
//## auto_generated
import com.ilogix.rhapsody.oxf.states.*;
//## auto_generated
import com.ilogix.rhapsody.oxf.services.*;
//## auto_generated
import com.ilogix.rhapsody.oxf.timeouts.*;
//## link displayMasterClock 
import ApplicationSystem.DisplayMasterClock;

//----------------------------------------------------------------------------
// DelayReqRespMaster/MasterClock.java                                                                  
//----------------------------------------------------------------------------

//## package DelayReqRespMaster 


//## class MasterClock 
public class MasterClock extends OrdinaryClock implements Runnable{
    
    protected static int DatagramBufferLength = 512;		//## attribute DatagramBufferLength 
    
    /**
    PTP-primary	All except peer delay mechanism messages	224.0.1.129	
    */
    protected static String PDelayMulticastGroupIPv4IPAddress = "224.0.0.107";		//## attribute PDelayMulticastGroupIPv4IPAddress 
    
    /**
    PTP-primary	All except peer delay mechanism messages	FF0X:0:0:0:0:0:0:181 see NOTE	
    NOTE - The hexidecial values for X in the PTP-primary address are defined in RFC 4291 [M13]. These are:
             0  reserved
             1  Interface-Local scope
             2  Link-Local scope
             3  reserved
    */
    protected String PDelayMulticastGroupIPv6IPAddress = "FF02:0:0:0:0:0:0:6B" ;		//## attribute PDelayMulticastGroupIPv6IPAddress 
    
    /**
    PTP-pdelay	Peer delay mechanism messages	224.0.0.107	
    */
    protected static String PrimaryMulticastGroupIPv4IPAddress = "224.0.1.129";		//## attribute PrimaryMulticastGroupIPv4IPAddress 
    
    /**
    PTP-pdelay	Peer delay mechanism messages	FF02:0:0:0:0:0:0:6B	
    */
    protected String PrimaryMulticastGroupIPv6IPAddress = "FF0X:0:0:0:0:0:0:181";		//## attribute PrimaryMulticastGroupIPv6IPAddress 
    
    public boolean delayRequestResponseFlag = false;		//## attribute delayRequestResponseFlag 
    
    protected Delay_Resp delayResp;		//## attribute delayResp 
    
    /**
    The UDP destination port of an event message shall be 319.  
    */
    protected static int eventMsgMulticastDestinationPort = 319;		//## attribute eventMsgMulticastDestinationPort 
    
    protected MulticastSocket eventMsgMulticastSocket;		//## attribute eventMsgMulticastSocket 
    
    protected Follow_Up followUp;		//## attribute followUp 
    
    protected long followUpTime;		//## attribute followUpTime 
    
    protected Timestamp followUpTimestamp;		//## attribute followUpTimestamp 
    
    /**
    The UDP destination port of a multicast general message shall be 320.  
    */
    protected static int generalMsgMulticastDestinationPort = 320;		//## attribute generalMsgMulticastDestinationPort 
    
    protected MulticastSocket generalMsgMulticastSocket;		//## attribute generalMsgMulticastSocket 
    
    protected long masterTime1;		//## attribute masterTime1 
    
    protected long masterTime2;		//## attribute masterTime2 
    
    protected Timestamp masterTimestamp1;		//## attribute masterTimestamp1 
    
    protected Timestamp masterTimestamp2;		//## attribute masterTimestamp2 
    
    protected long slaveTime2;		//## attribute slaveTime2 
    
    protected Timestamp slaveTimestamp2;		//## attribute slaveTimestamp2 
    
    protected Sync sync;		//## attribute sync 
    
    /**
    The UDP destination port of a unicast general message that is addressed to a clock shall be 320.  
    */
    protected static int unicastGeneralMsgDestinationPort = 320;		//## attribute unicastGeneralMsgDestinationPort 
    
    protected DisplayMasterClock displayMasterClock;		//## link displayMasterClock 
    
    
    // Constructors
    
    //## operation MasterClock() 
    public  MasterClock() {
        //#[ operation MasterClock() 
        this.localClock = new LocalClock();
        
        this.initialization();	 
        this.delayRequestResponseFlag = false; 
        this.run();
            
        
        
        //#]
    }
    
    //## operation StopMasterClockTimeSync() 
    public void StopMasterClockTimeSync() {
        //#[ operation StopMasterClockTimeSync() 
         this.delayRequestResponseFlag = false; 
         
        //#]
    }
    
    //## operation delayRequestResponse() 
    public void delayRequestResponse() {
        //#[ operation delayRequestResponse() 
        this.delayRequestResponseFlag=true; 
        
        
        
        //#]
    }
    
    //## operation initialization() 
    public void initialization() {
        //#[ operation initialization() 
            // Initilization of ordinaryClock
            System.out.println("MasterClock: ");
        	//System.out.println("In the Initilization() ");    
            //## attribute clockAccuracy 
            this.clockAccuracy= new ClockAccuracy((byte)22);	
            // 22 - The time is accurate to within 250 ns	
            
            //## attribute clockClass 
            this.clockClass= new ClockClass((byte)6);		
            //class 6 Shall designate a clock  that is synchronized to a primary reference time source. 
            //The timescale distributed shall be PTP. 
            //A clockClass 6 clock shall not be a slave to another clock in the domain.  
            
            //## attribute numberPorts 
            this.numberPorts= new UInteger16((short)1);		  
            // the number of port  of master ordinary clock is 1
            
            
            //## attribute offsetScaledLogVariance 
            this.offsetScaledLogVariance= new UInteger16((short)11);		
            //
            
            //## attribute priority1 
            this.priority1= new UInteger8((byte)1);	
            // 0-255	
            
            //## attribute priority2 
            this.priority2= new UInteger8((byte)1);		
            // 0-255
            
            //## attribute timeSource 
           this.timeSource= new TimeSource((byte)40);
           //40-PTP,	Any device synchronized to a PTP based source of time external to the domain 
            
            //## link localClock 
            this.localClock= new LocalClock();	// for get time setamp	
            
            //================================================
            //OClockCurrentDS 
            UInteger16 stepsRemoved = new UInteger16((short)0);     //The initialization value shall be 0.
             
            Integer64 offsetFMaster=new Integer64((long)1000000);     //nanoseconds                        
            TimeInterval offsetFromMaster = new TimeInterval(offsetFMaster);      
                                
            Integer64 meanPDelay=new Integer64((long)1000000);  //nanoseconds                               
            TimeInterval meanPathDelay   = new TimeInterval(meanPDelay);    
            
            this.oClockCurrentDS = new OClockCurrentDS(stepsRemoved,offsetFromMaster,meanPathDelay);		
        
            //================================================
            //OClockDefaultDS   
         	_Boolean twoStepFlag = new _Boolean((boolean)true);  
         	// true - two step clock need fFollowup message
         	 
         	
         	byte[] octets ={(byte)0x00,(byte)0x52,(byte)0x14,(byte)0x00,(byte)0x19,(byte)0xD1,(byte)0xE1,(byte)0x06};
         	//byte[] octets ={(byte)0,(byte)82,(byte)20,(byte)0,(byte)25,(byte)209,(byte)225,(byte)206};
         	
         	//octets[0]= (byte)0x00;  // NIST
         	//octets[1]= (byte)0x52;  // 0x52=82
         	//octets[2]= (byte)0x14;  // 14=20 --- SADP group
         	 
         	 //MAC Address of sensor 2 machine
         	//octets[3]= (byte)0x00;
         	//octets[4]= (byte)0x19;   //25
         	//octets[5]= (byte)0xD1;   // 209
         	//octets[6]= (byte)0xE1;    // 225
         	//octets[7]= (byte)0x06;    //6
         	//oa.octets[8]= (byte)0xCE; // 206
         	OctetArray oa=new OctetArray(octets);
         	
         	//byte[] octets={(byte)0H00,(byte)0H82,(byte)0H20,(byte)0H00,(byte)0H07,(byte)0HE9,(byte)0H76,(byte)0HE1};    
         	//oa.setOctets(8, octets);
         	ClockIdentity clockIdentity = new  ClockIdentity(oa) ;   
         	
         	// port number
         	UInteger16 numberPorts  =new UInteger16((short)1); 
         	// one port (slave port)   
         	 
         	// clocl quality 
         	ClockClass clockClass   = this.clockClass; 
         	ClockAccuracy clockAccuracy = this.clockAccuracy;
         	UInteger16 offsetScaledLogVariance =  this.offsetScaledLogVariance; 
         		
            ClockQuality clockQuality = new  ClockQuality(clockClass,clockAccuracy,offsetScaledLogVariance); 
         	                
         	                
         	UInteger8 priority1 = this.priority1;
         	UInteger8 priority2 = this.priority2;
         	Domain domainNumber = new Domain ((byte)0); 
         	// default domain is 0
         	_Boolean slaveOnly = new _Boolean((boolean)false);  
         	
         	//Boolean slaveOnly  = new Boolean(false);
           this.oClockDefaultDS = new OClockDefaultDS(twoStepFlag,clockIdentity,numberPorts,clockQuality,priority1,priority2,domainNumber,slaveOnly) ;
        
        
           //=========oClockParentDS==========================================
            //OClockParentDS 
        	
         	//ClockIdentity clockIdentity = new  ClockIdentity(oa) ;     
         	UInteger16 portNo=new UInteger16((short)1);// default port 0
        
         	PortIdentity parentPortIdentity= new PortIdentity(clockIdentity,portNo) ;	
          
          
          _Boolean parentStats=new _Boolean((boolean)true);	// port is in slave state
          	
          UInteger16 observedParentOffsetScaledLogVariance = new UInteger16((int)65535);
          		
          Integer32 observedParentClockPhaseChangeRate = new Integer32((int)2147483647);
          		              //The initialization value shall be 7FFF FFFF16 
          		              
          		              
          ClockIdentity grandmasterIdentity=this.oClockDefaultDS.getClockIdentity();		
          
          ClockQuality grandmasterClockQuality=this.oClockDefaultDS.getClockQuality();		
          	
          UInteger8 grandmasterPriority1=this.priority1;		
          UInteger8 grandmasterPriority2=this.priority2;		
            
            
           this.oClockParentDS= new OClockParentDS(parentPortIdentity,parentStats, observedParentOffsetScaledLogVariance, observedParentClockPhaseChangeRate, grandmasterIdentity, grandmasterClockQuality, grandmasterPriority1, grandmasterPriority2); 
               
            
        		
            
            //==========================================
        
           
            TimeInterval currentUtcOffset = new TimeInterval(new Integer64((long)33));	 //
            
            _Boolean currentUtcOffsetValid = new _Boolean((boolean)true);		
            
            _Boolean leap59 = new _Boolean((boolean)true);		
          
            _Boolean leap61 = new _Boolean((boolean)true);  // PTP  
            
            _Boolean timeTraceable = new _Boolean((boolean)true);
            		
            _Boolean frequencyTraceable = new _Boolean((boolean)true);	
            
            _Boolean ptpTimescale = new _Boolean((boolean)true);		
        
            TimeSource timeSource = new TimeSource((byte)0x40);	// 0x40 is 	PTP
        
            
            
            this.oClockTimePropertiesDS= new OClockTimePropertiesDS(currentUtcOffset, currentUtcOffsetValid,leap59, leap61, timeTraceable, frequencyTraceable, ptpTimescale, timeSource);
            //## link oClockTimePropertiesDS 
            
         //======================
          
           
        //PortIdentity portIdentity=  
             
            // Local IP is 129.6.73.8  = 0x81, 0x6, 0x49, 0x8
             byte[] ipAdd={(byte)0x81,(byte)0x6,(byte)0x49,(byte)0x8};
            OctetArray addressField=new OctetArray(ipAdd);		//## attribute addressField 
            
            
            UInteger16 addressLength=new UInteger16((short)4);	// IPV4 ***.***.***.***
            //## attribute addressLength 
            
            NetworkProtocol networkProtocol =new NetworkProtocol((short)1); // IPV4
            //## attribute networkProtocol 
        
        	PortAddress portAddress= new PortAddress(networkProtocol, addressLength, addressField);
        
        
        	//PTPPortState portState= new PTPPortState((short)1); // master=1
        	DelayMechanism delayMechanism = new DelayMechanism((short)0); // 0- delayrequest-response, 1- peerDelay		
        
        	DelayMechanism pathDelayMeasurementMechanism = delayMechanism;
        	//Version versionNumber= 
        	Timestamp timestamp= localClock.getTimestamp(); // ????
        	EventInterface eventInterface= new EventInterface(); 
        	GeneralInterface generalInterface= new GeneralInterface();
        
           //=======================================================================
            //## link oClockPort 
        
        
              
            //UInteger16 portNo=new UInteger16((short)1);// default port 0  
         	//ClockIdentity clockIdentity = new  ClockIdentity(oa) ;   
            
            PortIdentity portIdentity= new PortIdentity(clockIdentity,portNo) ;	
          
            //## attribute portIdentity 
            
            
             
            PTPPortState portState = new PTPPortState((short)1);	//01-initializing
            //## attribute portState  
        	//INITIALIZING	01
        	//FAULTY	02
        	//DISABLED	03
        	//LISTENING	04
        	//PRE_MASTER	05
        	//MASTER	06
        	//PASSIVE	07
        	//UNCALIBRATED	08
        	//SLAVE	09
            
            
            Integer8 logMinDelayReqInterval = new Integer8((byte)0); //(new Integer64((long)1000000));		// 1000000 nanoseconds
          
            //TimeInterval logMinDelayReqInterval = new TimeInterval(new Integer64((long)1000000));		// 1000000 nanoseconds
            //## attribute logMinDelayReqInterval 
        
            Integer8  logAnnounceInterval = new Integer8((byte)0);
            //TimeInterval logAnnounceInterval = new TimeInterval( new Integer64((long)1000000));		
            //## attribute logAnnounceInterval 
            
            UInteger8 announceReceiptTimeout = new UInteger8((byte)0);
            //TimeInterval announceReceiptTimeout = new TimeInterval(new Integer64((long)1000000));		
            //## attribute announceReceiptTimeout 
         
            Integer8 logSyncInterval = new Integer8((byte)0);
            //TimeInterval logSyncInterval = new TimeInterval(new Integer64((long)1000000));		
            //## attribute logSyncInterval     
            
            TimeInterval peerMeanPathDelay = new TimeInterval(new Integer64((long)1000000));		
            //## attribute peerMeanPathDelay 
        
            
            //DelayMechanism delayMechanism = new DelayMechanism((short)0); // 0- delayrequest-response, 1- peerDelay		
            //## attribute delayMechanism 
            Integer8 logMinPdelayReqInterval= new Integer8((byte)0);
            //TimeInterval logMinPdelayReqInterval = new TimeInterval(new Integer64((long)1000000));		
            //## attribute logMinPdelayReqInterval 
             
             UInteger4 versionNumber = new UInteger4((byte)0);
             //Version versionNumber = new Version();	    
               
           OClockPortDS oClockPortDS = new OClockPortDS(portIdentity,portState,logMinDelayReqInterval,peerMeanPathDelay,logAnnounceInterval,announceReceiptTimeout,logSyncInterval,delayMechanism,logMinPdelayReqInterval,versionNumber) ;
          //  public  OClockPortDS(portIdentity, final PTPState portState, final TimeInterval logMinDelayReqInterval, final TimeInterval peerMeanPathDelay, final TimeInterval logAnnounceInterval, final TimeInterval announceReceiptTimeout, final TimeInterval logSyncInterval, final DelayMechanism delayMechanism, final TimeInterval logMinPdelayReqInterval, final Version versionNumber) {
        
                        
            //PTPPortState portState = new PTPPortState((short)6);	//06-MASTER	
        
        
        //ForeignMasterDS foreighMasterDS
        //====================ForeighMasterDS==========    
             UInteger8 foreignMasterAnnounceMessages =new UInteger8((byte)4 );		//## attribute foreignMasterAnnounceMessages 
            
             PortIdentity foreignMasterPortIdentity = new PortIdentity(clockIdentity,portNo);		//## attribute foreignMasterPortIdentity 
          
             ForeignMasterDS foreignMasterDS = new  ForeignMasterDS(foreignMasterAnnounceMessages, foreignMasterPortIdentity);
               
        
          this.oClockPort = new OClockPort(portIdentity,portAddress,portState,pathDelayMeasurementMechanism,versionNumber,timestamp,eventInterface,generalInterface,oClockPortDS,foreignMasterDS);
            
        
        this.delayRequestResponse();    
        
        //#]
    }
    
    //## operation masterTimeSynchronization() 
    public void masterTimeSynchronization() {
        //#[ operation masterTimeSynchronization() 
        //System.out.println("In the run()");
        
        
        
         int i=0;    
           String numberOfLoopsStr=""; 
           String masterTime1Str=""; 
           String masterFollowUpTimeStr=""; 
           String slaveTime1Str=""; 
           String masterTime2Str=""; 
         this.displayMasterClock = new DisplayMasterClock();    
         
        while(this.delayRequestResponseFlag)
        {
           i++;
           System.out.println("\n\n\n=======================================");  
           System.out.println("No. of Loops:="+i);  
           numberOfLoopsStr=new String(new Integer(i).toString());
        
          try{                
        		Thread.sleep(1000);
         }catch (Exception e){}     
         
           
         // setup Sync msg header             
         MessageHeader syncMsgHeader = new MessageHeader();  
         
         Nibble syncTransportSpecific =new Nibble((byte)1); 
         syncMsgHeader.setTransportSpecific(syncTransportSpecific); 
         
         MessageType syncMessageType=new MessageType((byte)0);   //0-sync
         syncMsgHeader.setMessageType(syncMessageType);  
         
         Nibble syncReserved1 =new Nibble((byte)0);    // 0 - null
         syncMsgHeader.setReserved1(syncReserved1);   
         
         //UInteger4 versionPTP = this.oClockPort.getOClockPortDS().getVersionNumber();// new Version((byte)2);
         UInteger4 syncVersionPTP = new UInteger4((byte)2);   // 2- version2, 1- version1
         syncMsgHeader.setVersionPTP(syncVersionPTP); 
         
         UInteger16 syncMessageLength = new  UInteger16((short)64); // 64 bytes
         syncMsgHeader.setMessageLength(syncMessageLength); 
         
         Domain syncDomainNumber = new Domain((byte)0);   // 0- default domain UInteger8
         syncMsgHeader.setDomainNumber(syncDomainNumber);  
         
         UInteger8 syncReserved2 = new  UInteger8((byte)0);
         syncMsgHeader.setReserved2(syncReserved2);    
                                        
         byte[] syncFlagFieldOctets = {0,1};
                                        
         OctetArray syncFlagField =new OctetArray(syncFlagFieldOctets);
         syncMsgHeader.setFlagField(syncFlagField);   
         
         Integer64 syncCorrectionField   = new Integer64((long)0);
         syncMsgHeader.setCorrectionField(syncCorrectionField);  
         
         UInteger32 syncReserved3 = new UInteger32((long)0);
         syncMsgHeader.setReserved3(syncReserved3);    
         
         PortIdentity syncSourcePortIdentity = this.oClockPort.getOClockPortDS().getPortIdentity();//   = new  PortIdentity() ;
         syncMsgHeader.setSourcePortIdentity(syncSourcePortIdentity);  
         
         UInteger16 syncSequenceId =  new UInteger16((short)101);
         syncMsgHeader.setSequenceId(syncSequenceId);   
         
         UInteger8 syncControlField = new UInteger8((byte)0) ;      // 00- sysnc
         syncMsgHeader.setControlField(syncControlField);   
         
         Integer8 syncLogMessageInterval  = new Integer8();//this.oClockPort.getOClockPortDS().getLogSyncInterval();//new Integer8();                                  
         syncMsgHeader.setLogMessageInterval(syncLogMessageInterval);     
         
         //syncMsgHeader.PrintMessageHeader();
            
            
        // Sync Msg      
        //System.out.println("Define a Sync MSG.");   
         
        //this.localClock = new LocalClock();
         
        		masterTimestamp1=new Timestamp();
        		
        		masterTimestamp1=this.localClock.GetClockTimestamp();
             	 
             	masterTime1= masterTimestamp1.getNanosecondsField().getUinteger32Val()/1000000+ masterTimestamp1.getSecondsField().getUinteger48Val()*1000;  
              
        System.out.println("\nSend  a Sync Msg.");
        System.out.println("\nMasterTime1(Sync)=:"+masterTime1);    
        masterTime1Str=new String(new Long(masterTime1).toString());  
        
        Date masterTime1Date = new Date(masterTime1);  
        String  masterTime1DateStr= new String(DateFormat.getDateTimeInstance(DateFormat.LONG, DateFormat.LONG).format(masterTime1).toString());
        System.out.println("New type:"+masterTime1DateStr);
        
        masterTime1Str=masterTime1Str+" ("+masterTime1DateStr+")";
         
        this.sync = new Sync(syncMsgHeader, masterTimestamp1);  
          
        //this.sync.PrintSync();
        
          
        
        	//System.out.println("Call Sync() of event interface");
        	this.oClockPort.eventInterface.Sync(this.sync);    
        	
        
         
          
        if((this.oClockDefaultDS.getTwoStepFlag()).getBooleanVal()==true)
        {        
        		        try{                
        		          Thread.sleep(100);
        		        }catch (Exception e){}     
                          
        
         // Follow_UP header    
         //System.out.println("Define a FollowUp MSG. Header");
         MessageHeader followUpMsgHeader=new MessageHeader();  
         
         Nibble followUpTransportSpecific =new Nibble((byte)1); 
         followUpMsgHeader.setTransportSpecific(followUpTransportSpecific); 
         
         MessageType followUpMessageType=new MessageType((byte)8);   //8-Follow_UP
         followUpMsgHeader.setMessageType(followUpMessageType);  
         
         Nibble followUpReserved1 =new Nibble((byte)0);    // 0 - null
         followUpMsgHeader.setReserved1(followUpReserved1);   
         
         //UInteger4 versionPTP = this.oClockPort.getOClockPortDS().getVersionNumber();// new Version((byte)2);
         UInteger4 followUpVersionPTP = new UInteger4((byte)2);   // 2- version2, 1- version1
         followUpMsgHeader.setVersionPTP(followUpVersionPTP); 
         
         UInteger16 followUpMessageLength = new  UInteger16((short)44); // 44 bytes
         followUpMsgHeader.setMessageLength(followUpMessageLength); 
         
         Domain followUpDomainNumber = new Domain((byte)0);   // 0- default domain UInteger8
         followUpMsgHeader.setDomainNumber(followUpDomainNumber);  
         
         UInteger8 followUpReserved2 = new  UInteger8((byte)0);
         followUpMsgHeader.setReserved2(followUpReserved2);    
         
         byte[]  followUpFlagFieldOctets= {0,0};
         
         OctetArray followUpFlagField =new OctetArray(followUpFlagFieldOctets);
         followUpMsgHeader.setFlagField(followUpFlagField);   
         
         Integer64 followUpCorrectionField   = new Integer64((long)0);
         followUpMsgHeader.setCorrectionField(followUpCorrectionField);  
         
         UInteger32 followUpReserved3 = new UInteger32((long)0);
         followUpMsgHeader.setReserved3(followUpReserved3);    
         
         PortIdentity followUpSourcePortIdentity = this.oClockPort.getOClockPortDS().getPortIdentity();//   = new  PortIdentity() ;
         followUpMsgHeader.setSourcePortIdentity(followUpSourcePortIdentity);  
         
         UInteger16 followUpSequenceId =  new UInteger16((short)102);
         followUpMsgHeader.setSequenceId(followUpSequenceId);   
         
         UInteger8 followUpControlField = new UInteger8((byte)2) ;      // 02- Follow_up
         followUpMsgHeader.setControlField(followUpControlField);   
         
         Integer8 followUpLogMessageInterval  = new Integer8();//this.oClockPort.getOClockPortDS().getLogSyncInterval();//new Integer8();                                  
         followUpMsgHeader.setLogMessageInterval(followUpLogMessageInterval); 
         // System.out.println("Define a FollowUp MSG. ");
          
        // followUpMsgHeader.PrintMessageHeader();
          
        // Follwo_Up msg   
        this.followUpTimestamp =  masterTimestamp1; //this.localClock.GetClockTimestamp() ;
        
        this.followUpTime = followUpTimestamp.getNanosecondsField().getUinteger32Val()/1000000+ followUpTimestamp.getSecondsField().getUinteger48Val()*1000;  
        
        this.followUp = new Follow_Up(followUpMsgHeader,followUpTimestamp)  ;
        //this.followUp.PrintFollowUp();   
        
        System.out.println("\nSend a FolloUp msg. ");
        System.out.println("\nMasterTime1(FollowUp)=:"+followUpTime); 
        masterFollowUpTimeStr= new String(new Long(followUpTime).toString()); 
        
        Date masterFollowUpTimeDate = new Date(followUpTime);  
        //String  masterFollowUpTimeDateStr= new String(DateFormat.getDateTimeInstance(DateFormat.LONG, DateFormat.LONG).format(followUpTime).toString());
        String  masterFollowUpTimeDateStr=        new String(DateFormat.getDateTimeInstance(DateFormat.LONG, DateFormat.LONG).format(followUpTime).toString());
        
        System.out.println("New type:"+masterFollowUpTimeDateStr);
        
        masterFollowUpTimeStr=masterFollowUpTimeStr+" ("+masterFollowUpTimeDateStr+")";
        
        this.oClockPort.generalInterface.FollowUp(this.followUp);    
              }
        
         
        //Receiveing Delay_Req message
        		  
        		  try
        		  {     
        		  
                        //System.out.println("Create Socket for receiving delayRequest msg ");  
                        eventMsgMulticastSocket= new MulticastSocket(eventMsgMulticastDestinationPort);
                    	
                		eventMsgMulticastSocket = new MulticastSocket(eventMsgMulticastDestinationPort);
        
                		//System.out.println("Join group");
                		eventMsgMulticastSocket.joinGroup(InetAddress.getByName(PrimaryMulticastGroupIPv4IPAddress));
        
        				
        				byte[] buf1 = new byte[DatagramBufferLength];
                        
                        //System.out.println("create delay request packet."); 
        				DatagramPacket slaveDelayRequestPacket = new DatagramPacket(buf1, buf1.length);
                        
                        System.out.println("Receive a delay request msg.");
                         
        				eventMsgMulticastSocket.receive(slaveDelayRequestPacket); 
        				
        				byte[] delayReqData = slaveDelayRequestPacket.getData();
        				int length=slaveDelayRequestPacket.getLength();
                        
                         
        				OctetArray oc = new OctetArray(delayReqData);
        				Delay_Req delayReq = new Delay_Req(oc);  
        				
        				//delayReq.PrintDelayReq();
        ////////-===========
        /*try{                
        		Thread.sleep(10);
         }catch (Exception e){}     
          */  
        				this.slaveTimestamp2 = delayReq.getOriginTimestamp();
             			this.slaveTime2 = this.slaveTimestamp2.getNanosecondsField().getUinteger32Val()/1000000+ this.slaveTimestamp2.getSecondsField().getUinteger48Val()*1000;  
             	
                                                       
                         
                        System.out.println("\nReceive a DelayRequest MSG.");
             			System.out.println("\nSlaveTime2=:"+slaveTime2);   
             			slaveTime1Str= new String(new Long(this.slaveTime2).toString());
        				
        				Date slaveTime1Date = new Date(slaveTime2);  
        				String  slaveTime1DateStr= new String(DateFormat.getDateTimeInstance(DateFormat.LONG, DateFormat.LONG).format(slaveTime2).toString());
        				System.out.println("New type:"+slaveTime1DateStr);
        				slaveTime1Str=slaveTime1Str+" ("+slaveTime1DateStr+")";
        		       /* try{                
        		          Thread.sleep(100000);
        		        }catch (Exception e){}     
                          */
                         
                        // Delay_Resp msg header  ===========
                         MessageHeader delayRespMsgHeader = new MessageHeader();  
        				 Nibble delayRespTransportSpecific =new Nibble((byte)1); 
        				 delayRespMsgHeader.setTransportSpecific(delayRespTransportSpecific); 
        				 
        				 MessageType delayRespMessageType=new MessageType((byte)9);   //9-delay_Resp
        				 delayRespMsgHeader.setMessageType(delayRespMessageType);  
        				 
        				 Nibble delayRespReserved1 =new Nibble((byte)0);    // 0 - null
        				 delayRespMsgHeader.setReserved1(delayRespReserved1);   
        				 
        				 //UInteger4 versionPTP = this.oClockPort.getOClockPortDS().getVersionNumber();// new Version((byte)2);
        				 UInteger4 delayRespVersionPTP = new UInteger4((byte)2);   // 2- version2, 1- version1
        				 delayRespMsgHeader.setVersionPTP(delayRespVersionPTP); 
        				 
        				 UInteger16 delayRespMessageLength = new  UInteger16((short)54); // 54 bytes
        				 delayRespMsgHeader.setMessageLength(delayRespMessageLength); 
        				 
        				 Domain delayRespDomainNumber = new Domain((byte)0);   // 0- default domain UInteger8
        				 delayRespMsgHeader.setDomainNumber(delayRespDomainNumber);  
        				 
        				 UInteger8 delayRespReserved2 = new  UInteger8((byte)0);
        				 delayRespMsgHeader.setReserved2(delayRespReserved2);    
        				 
        				 byte[]  delayRespFlagFieldOctets = {0,0};
        				 OctetArray delayRespFlagField =new OctetArray(delayRespFlagFieldOctets);  // 0 0 -delay-Resp
        				 delayRespMsgHeader.setFlagField(delayRespFlagField);   
        				 
        				 Integer64 delayRespCorrectionField   = new Integer64((long)0);
        				 delayRespMsgHeader.setCorrectionField(delayRespCorrectionField);  
        				 
        				 UInteger32 delayRespReserved3 = new UInteger32((long)0);
        				 delayRespMsgHeader.setReserved3(delayRespReserved3);    
        				 
        				 PortIdentity delayRespSourcePortIdentity = this.oClockPort.getOClockPortDS().getPortIdentity();//   = new  PortIdentity() ;
        				 delayRespMsgHeader.setSourcePortIdentity(delayRespSourcePortIdentity);  
        				 
        				 UInteger16 delayRespSequenceId =  new UInteger16((short)103);
        				 delayRespMsgHeader.setSequenceId(delayRespSequenceId);   
        				 
        				 UInteger8 delayRespControlField = new UInteger8((byte)3) ;      // 03- Delay_resp
        				 delayRespMsgHeader.setControlField(delayRespControlField);  
        				  
        				 
        				 Integer8 delayRespLogMessageInterval  = new Integer8();//this.oClockPort.getOClockPortDS().getLogSyncInterval();//new Integer8();                                  
        				 delayRespMsgHeader.setLogMessageInterval(delayRespLogMessageInterval); 
                         
                        // Delay_Resp msg 
                        masterTimestamp2 = new Timestamp();
                        masterTimestamp2=this.localClock.GetClockTimestamp() ;
                        this.delayResp=new Delay_Resp(delayRespMsgHeader,masterTimestamp2,this.oClockPort.getOClockPortDS().getPortIdentity());
                        
                        //this.delayResp.PrintDelayResp();
                        System.out.println("\nSend a delay response msg. ");    
                        //masterTime2= this.localClock.getMilliSeconds();
                        long masterTime2=  masterTimestamp2.getNanosecondsField().getUinteger32Val()/1000000+ masterTimestamp2.getSecondsField().getUinteger48Val()*1000;  
         
                        //System.out.println("\nMasterTime2=:"+this.localClock.getNanoseconds());  
                        
                        masterTime2Str=new String(new Long(masterTime2).toString());    
        				
        				Date masterTime2Date = new Date(masterTime2);  
        				String  masterTime2DateStr= new String(DateFormat.getDateTimeInstance(DateFormat.LONG, DateFormat.LONG).format(masterTime2).toString());
        				System.out.println("New type:"+masterTime2DateStr);
        				masterTime2Str=masterTime2Str+" ("+masterTime2DateStr+")";
                        
                        
                        
                        this.oClockPort.generalInterface.DelayResponse(this.delayResp);
            
            
                      this.displayMasterClock.displayMasterClock(numberOfLoopsStr,masterTime1Str,masterFollowUpTimeStr,slaveTime1Str,masterTime2Str)  ;
             
                       numberOfLoopsStr=""; 
        			   masterTime1Str=""; 
        			   masterFollowUpTimeStr=""; 
        			   slaveTime1Str=""; 
        			   masterTime2Str=""; 
          
                                  
        			} catch(IOException e)
        			{
        				e.printStackTrace();
        				System.exit(2);
        			}              
          }         
        //#]
    }
    
    //## operation run() 
    public void run() {
        //#[ operation run() 
        
        		if(this.delayRequestResponseFlag)
        		{
        			 this.masterTimeSynchronization();         
        			 this.delayRequestResponseFlag = false; 
        			 System.out.println("Flag:"+this.delayRequestResponseFlag);  
        		}
        
        //#]
    }
    
    //## auto_generated 
    public static int getDatagramBufferLength() {
        return DatagramBufferLength;
    }
    
    //## auto_generated 
    public static void setDatagramBufferLength(int p_DatagramBufferLength) {
        DatagramBufferLength = p_DatagramBufferLength;
    }
    
    //## auto_generated 
    public static String getPDelayMulticastGroupIPv4IPAddress() {
        return PDelayMulticastGroupIPv4IPAddress;
    }
    
    //## auto_generated 
    public static void setPDelayMulticastGroupIPv4IPAddress(String p_PDelayMulticastGroupIPv4IPAddress) {
        PDelayMulticastGroupIPv4IPAddress = p_PDelayMulticastGroupIPv4IPAddress;
    }
    
    //## auto_generated 
    public String getPDelayMulticastGroupIPv6IPAddress() {
        return PDelayMulticastGroupIPv6IPAddress;
    }
    
    //## auto_generated 
    public void setPDelayMulticastGroupIPv6IPAddress(String p_PDelayMulticastGroupIPv6IPAddress) {
        PDelayMulticastGroupIPv6IPAddress = p_PDelayMulticastGroupIPv6IPAddress;
    }
    
    //## auto_generated 
    public static String getPrimaryMulticastGroupIPv4IPAddress() {
        return PrimaryMulticastGroupIPv4IPAddress;
    }
    
    //## auto_generated 
    public static void setPrimaryMulticastGroupIPv4IPAddress(String p_PrimaryMulticastGroupIPv4IPAddress) {
        PrimaryMulticastGroupIPv4IPAddress = p_PrimaryMulticastGroupIPv4IPAddress;
    }
    
    //## auto_generated 
    public String getPrimaryMulticastGroupIPv6IPAddress() {
        return PrimaryMulticastGroupIPv6IPAddress;
    }
    
    //## auto_generated 
    public void setPrimaryMulticastGroupIPv6IPAddress(String p_PrimaryMulticastGroupIPv6IPAddress) {
        PrimaryMulticastGroupIPv6IPAddress = p_PrimaryMulticastGroupIPv6IPAddress;
    }
    
    //## auto_generated 
    public boolean getDelayRequestResponseFlag() {
        return delayRequestResponseFlag;
    }
    
    //## auto_generated 
    public void setDelayRequestResponseFlag(boolean p_delayRequestResponseFlag) {
        delayRequestResponseFlag = p_delayRequestResponseFlag;
    }
    
    //## auto_generated 
    public Delay_Resp getDelayResp() {
        return delayResp;
    }
    
    //## auto_generated 
    public void setDelayResp(Delay_Resp p_delayResp) {
        delayResp = p_delayResp;
    }
    
    //## auto_generated 
    public static int getEventMsgMulticastDestinationPort() {
        return eventMsgMulticastDestinationPort;
    }
    
    //## auto_generated 
    public static void setEventMsgMulticastDestinationPort(int p_eventMsgMulticastDestinationPort) {
        eventMsgMulticastDestinationPort = p_eventMsgMulticastDestinationPort;
    }
    
    //## auto_generated 
    public MulticastSocket getEventMsgMulticastSocket() {
        return eventMsgMulticastSocket;
    }
    
    //## auto_generated 
    public void setEventMsgMulticastSocket(MulticastSocket p_eventMsgMulticastSocket) {
        eventMsgMulticastSocket = p_eventMsgMulticastSocket;
    }
    
    //## auto_generated 
    public Follow_Up getFollowUp() {
        return followUp;
    }
    
    //## auto_generated 
    public void setFollowUp(Follow_Up p_followUp) {
        followUp = p_followUp;
    }
    
    //## auto_generated 
    public long getFollowUpTime() {
        return followUpTime;
    }
    
    //## auto_generated 
    public void setFollowUpTime(long p_followUpTime) {
        followUpTime = p_followUpTime;
    }
    
    //## auto_generated 
    public Timestamp getFollowUpTimestamp() {
        return followUpTimestamp;
    }
    
    //## auto_generated 
    public void setFollowUpTimestamp(Timestamp p_followUpTimestamp) {
        followUpTimestamp = p_followUpTimestamp;
    }
    
    //## auto_generated 
    public static int getGeneralMsgMulticastDestinationPort() {
        return generalMsgMulticastDestinationPort;
    }
    
    //## auto_generated 
    public static void setGeneralMsgMulticastDestinationPort(int p_generalMsgMulticastDestinationPort) {
        generalMsgMulticastDestinationPort = p_generalMsgMulticastDestinationPort;
    }
    
    //## auto_generated 
    public MulticastSocket getGeneralMsgMulticastSocket() {
        return generalMsgMulticastSocket;
    }
    
    //## auto_generated 
    public void setGeneralMsgMulticastSocket(MulticastSocket p_generalMsgMulticastSocket) {
        generalMsgMulticastSocket = p_generalMsgMulticastSocket;
    }
    
    //## auto_generated 
    public long getMasterTime1() {
        return masterTime1;
    }
    
    //## auto_generated 
    public void setMasterTime1(long p_masterTime1) {
        masterTime1 = p_masterTime1;
    }
    
    //## auto_generated 
    public long getMasterTime2() {
        return masterTime2;
    }
    
    //## auto_generated 
    public void setMasterTime2(long p_masterTime2) {
        masterTime2 = p_masterTime2;
    }
    
    //## auto_generated 
    public Timestamp getMasterTimestamp1() {
        return masterTimestamp1;
    }
    
    //## auto_generated 
    public void setMasterTimestamp1(Timestamp p_masterTimestamp1) {
        masterTimestamp1 = p_masterTimestamp1;
    }
    
    //## auto_generated 
    public Timestamp getMasterTimestamp2() {
        return masterTimestamp2;
    }
    
    //## auto_generated 
    public void setMasterTimestamp2(Timestamp p_masterTimestamp2) {
        masterTimestamp2 = p_masterTimestamp2;
    }
    
    //## auto_generated 
    public long getSlaveTime2() {
        return slaveTime2;
    }
    
    //## auto_generated 
    public void setSlaveTime2(long p_slaveTime2) {
        slaveTime2 = p_slaveTime2;
    }
    
    //## auto_generated 
    public Timestamp getSlaveTimestamp2() {
        return slaveTimestamp2;
    }
    
    //## auto_generated 
    public void setSlaveTimestamp2(Timestamp p_slaveTimestamp2) {
        slaveTimestamp2 = p_slaveTimestamp2;
    }
    
    //## auto_generated 
    public Sync getSync() {
        return sync;
    }
    
    //## auto_generated 
    public void setSync(Sync p_sync) {
        sync = p_sync;
    }
    
    //## auto_generated 
    public static int getUnicastGeneralMsgDestinationPort() {
        return unicastGeneralMsgDestinationPort;
    }
    
    //## auto_generated 
    public static void setUnicastGeneralMsgDestinationPort(int p_unicastGeneralMsgDestinationPort) {
        unicastGeneralMsgDestinationPort = p_unicastGeneralMsgDestinationPort;
    }
    
    //## auto_generated 
    public DisplayMasterClock getDisplayMasterClock() {
        return displayMasterClock;
    }
    
    //## auto_generated 
    public void setDisplayMasterClock(DisplayMasterClock p_DisplayMasterClock) {
        displayMasterClock = p_DisplayMasterClock;
    }
    
}
/*********************************************************************
	File Path	: DelayReqRespMaster/MasterClock/DelayReqRespMaster/MasterClock.java
*********************************************************************/

