/*********************************************************************
	Rhapsody	: 7.1
	Login		: ysong_a
	Component	: DelayReqRespSlave
	Configuration 	: SlaveClock
	Model Element	: Announce
//!	Generated Date	: Mon, 28, Jul 2008 
	File Path	: DelayReqRespSlave/SlaveClock/PTPMessages/Announce.java
*********************************************************************/

package PTPMessages;

//## auto_generated
import java.util.*;
//## auto_generated
import PTPEnumTypes.*;
//## auto_generated
import PTPDerivedDataTypes.*;
//## attribute timeSource 
import PTPEnumTypes.TimeSource;
//## auto_generated
import PTPPrimitivityDataTypes.*;
//## auto_generated
import com.ilogix.rhapsody.oxf.*;
//## attribute originTimestamp 
import PTPDerivedDataTypes.Timestamp;
//## attribute announceMsg 
import PTPDerivedDataTypes.OctetArray;
//## attribute grandmasterClockQuality 
import PTPDerivedDataTypes.ClockQuality;
//## auto_generated
import com.ilogix.rhapsody.oxf.states.*;
//## attribute annonceReserved1 
import PTPPrimitivityDataTypes.UInteger8;
//## attribute grandmasterIdentity 
import PTPDerivedDataTypes.ClockIdentity;
//## attribute currentUtcOffset 
import PTPPrimitivityDataTypes.UInteger16;
//## auto_generated
import com.ilogix.rhapsody.oxf.services.*;
//## auto_generated
import com.ilogix.rhapsody.oxf.timeouts.*;

//----------------------------------------------------------------------------
// PTPMessages/Announce.java                                                                  
//----------------------------------------------------------------------------

//## package PTPMessages 


/**
Table 25: Announce message fields

Bits	Octets 	Offset 	
7	6	5	4	3	2	1	0			
header ( 13.3)	34	0	
originTimestamp	10	34	
currentUtcOffset	2	44	
reserved	1	46	
grandmasterPriority1	1	47	
grandmasterClockQuality 	4	48	
grandmasterPriority2	1	52	
grandmasterIdentity 	8	53	
stepsRemoved 	2	61	
timeSource  	1	63	
*/
//## class Announce 
public class Announce extends GeneralMessage {
    
    protected UInteger8 annonceReserved1;		//## attribute annonceReserved1 
    
    protected OctetArray announceMsg;		//## attribute announceMsg 
    
    protected OctetArray announceMsgOctetArray;		//## attribute announceMsgOctetArray 
    
    protected UInteger16 currentUtcOffset;		//## attribute currentUtcOffset 
    
    protected ClockQuality grandmasterClockQuality;		//## attribute grandmasterClockQuality 
    
    protected ClockIdentity grandmasterIdentity;		//## attribute grandmasterIdentity 
    
    protected UInteger8 grandmasterPriority1;		//## attribute grandmasterPriority1 
    
    protected UInteger8 grandmasterPriority2;		//## attribute grandmasterPriority2 
    
    protected Timestamp originTimestamp;		//## attribute originTimestamp 
    
    protected static short sizeOfMsg = 64;		//## attribute sizeOfMsg 
    
    protected UInteger8 stepsRemoved;		//## attribute stepsRemoved 
    
    protected TimeSource timeSource;		//## attribute timeSource 
    
    
    // Constructors
    
    //## operation Announce() 
    public  Announce() {
        //#[ operation Announce() 
        //#]
    }
    //## operation Announce(MessageHeader,Timestamp,UInteger16,UInteger8,UInteger8,ClockQuality,UInteger8,ClockIdentity,UInteger8,TimeSource) 
    public  Announce(final MessageHeader msgHeader, final Timestamp originTimestamp, final UInteger16 currentUtcOffset, final UInteger8 announceReserved1, final UInteger8 grandmasterPriority1, final ClockQuality grandmasterClockQuality, final UInteger8 grandmasterPriority2, final ClockIdentity grandmasterIdentity, final UInteger8 stepsRemoved, final TimeSource timeSource) {
        //#[ operation Announce(MessageHeader,Timestamp,UInteger16,UInteger8,UInteger8,ClockQuality,UInteger8,ClockIdentity,UInteger8,TimeSource) 
        
        
        
        
        /*this.originTimestamp = originTimestamp ;
        this.currentUtcOffset =currentUtcOffset ;
        this.announceReserved1 = announceReserved1  ;
        this.grandmasterPriority1 = grandmasterPriority1 ;
        this.grandmasterClockQuality = grandmasterClockQuality ;
        this.grandmasterPriority2 = grandmasterPriority2 ;
        this.grandmasterIdentity  = grandmasterIdentity ;
        this.stepsRemoved =  stepsRemoved ;
        this.timeSource  = timeSource ;  
        */
        
            this.messageHeader=messageHeader;  
            
            this.originTimestamp = originTimestamp;		
            this.currentUtcOffset = currentUtcOffset;		
            this.annonceReserved1 = annonceReserved1;		
            this.grandmasterPriority1 = grandmasterPriority1;		
            this.grandmasterClockQuality = grandmasterClockQuality;		
            this.grandmasterPriority2 = grandmasterPriority2;
            this.grandmasterIdentity = grandmasterIdentity;		
            this.sizeOfMsg = sizeOfMsg;		
            this.stepsRemoved = stepsRemoved;		
            this.timeSource = timeSource;
        //#]
    }
    //## operation Announce(OctetArray) 
    public  Announce(final OctetArray announceMsgOctetArray) {
        //#[ operation Announce(OctetArray) 
        // 34+30=44
        
        //this.syncMsg=new OctetArray((short)44);   
        
        this.announceMsgOctetArray = announceMsgOctetArray;// octetArray(44)  
        
        this.messageHeader = new MessageHeader();
              
        //this.messageHeader.octets[0]= (byte)((byte)(this.transportSpecific.nibbleVal<<4)|this.messageType.messageType)  ; 
        //messageType 
        byte messageTypeByte =(byte)(0x0FL&this.announceMsgOctetArray.octets[0]);  
        
        MessageType messageType=  new MessageType((byte)messageTypeByte) ;
        this.messageHeader.setMessageType(messageType);                                      //
               
        // transport Specific       
        byte transportSpecificByte=(byte)((byte)(0xFL)&(this.announceMsgOctetArray.octets[0]>>4)); 
        Nibble transportSpecific =new Nibble((byte)transportSpecificByte);
        this.messageHeader.setTransportSpecific(transportSpecific);
        
                    
        
        // reserved1              
        //this.messageHeader.octets[1]=(byte)((byte)(this.reserved1.nibbleVal<<4)|this.versionPTP.uinteger4Val)  ;  
        byte versionPTPByte= (byte)(0x0FL&this.announceMsgOctetArray.octets[1]);  
        UInteger4  versionPTP= new UInteger4((byte)versionPTPByte);
        this.messageHeader.setVersionPTP(versionPTP );
        
        // versionPTP 
        byte reserved1Byte=(byte)(0x0FL&this.announceMsgOctetArray.octets[1]>>4);  
        Nibble  reserved1= new Nibble((byte)reserved1Byte);
        this.messageHeader.setReserved1(reserved1);
        
        
        
        // messageLength
        //this.messageHeader.octets[2]= (byte)this.messageLength.uinteger16Val ;  
        //this.messageHeader.octets[3]= (byte)((byte)this.messageLength.uinteger16Val>>8) ; 
        short messageLengthByte1 = (short) ((0x00FFL)&this.announceMsgOctetArray.octets[2]);
        short messageLengthByte2 = (short) ((0xFF00L)&(this.announceMsgOctetArray.octets[3]<<8));   
        short messageLengthBytes= (short)(messageLengthByte1|messageLengthByte2);   
        PTPPrimitivityDataTypes.UInteger16  messageLength=  new PTPPrimitivityDataTypes.UInteger16((short)messageLengthBytes);
        this.messageHeader.setMessageLength(messageLength); 
         
        //domainNumber 
        //this.messageHeader.octets[4]= this.domainNumber.domain ; 
        byte domainNumberBye = (byte)((0x0FL)&this.announceMsgOctetArray.octets[4]);   
         //   public void setDomainNumber(Domain p_domainNumber) {
        PTPEntities.Domain domainNumber = new PTPEntities.Domain((byte)domainNumberBye);
        this.messageHeader.setDomainNumber(domainNumber); 
        
         // reserved2
        //this.messageHeader.octets[5]= (byte)this.reserved2.uinteger8Val  ; 
        UInteger8 reserved2= new UInteger8((byte)this.announceMsgOctetArray.octets[5]) ;
        this.messageHeader.setReserved2(reserved2);
                            
         //flags                    
        byte  flagFieldByteArray1= this.announceMsgOctetArray.octets[6];   
        byte  flagFieldByteArray2= this.announceMsgOctetArray.octets[7];
        byte[]  flagFieldByteArray ={flagFieldByteArray1,flagFieldByteArray2 };  
        
        OctetArray flagFieldOctetArray =    new OctetArray(flagFieldByteArray);   
        this.messageHeader.setFlagField(flagFieldOctetArray); 
        
        
        
        // correctionField
        long filedByte0 = (0x00000000000000FFL&this.announceMsgOctetArray.octets[8]);
        long filedByte1 = (0x000000000000FF00L&(this.announceMsgOctetArray.octets[9]<<8));    
        long filedByte2 = (0x0000000000FF0000L&(this.announceMsgOctetArray.octets[10]<<16)); 
        long filedByte3 = (0x00000000FF000000L&(this.announceMsgOctetArray.octets[11]<<24)); 
        long filedByte4 = (0x000000FF00000000L&(this.announceMsgOctetArray.octets[12]<<32)); 
        long filedByte5 = (0x0000FF0000000000L&(this.announceMsgOctetArray.octets[13]<<40)); 
        long filedByte6 = (0x00FF000000000000L&(this.announceMsgOctetArray.octets[14]<<48)); 
        long filedByte7 = (0xFF00000000000000L&(this.announceMsgOctetArray.octets[15]<<56));   
        long correctionFieldBytes=(long)(filedByte0|filedByte1|filedByte2|filedByte3|filedByte4|filedByte5|filedByte6|filedByte7) ;
        Integer64 correctionField = new Integer64((long)correctionFieldBytes);
        this.messageHeader.setCorrectionField(correctionField); 
                           
                                
        //reserved3                        
        
        int reserved3Byte0=  (int)(0x000000FFL& this.announceMsgOctetArray.octets[16]);
        int reserved3Byte1=  (int)(0x0000FF00L& this.announceMsgOctetArray.octets[17]<<8);
        int reserved3Byte2=  (int)(0x00FF0000L& this.announceMsgOctetArray.octets[18]<<16);
        int reserved3Byte3=  (int)(0xFF000000L& this.announceMsgOctetArray.octets[19]<<24);  
        int reserved3Bytes=  (int)(reserved3Byte0|reserved3Byte1|reserved3Byte2|reserved3Byte3)   ;  
        UInteger32 reserved3   = new UInteger32((int)reserved3Bytes);
        this.messageHeader.setReserved3(reserved3); 
        
        
        //sourcePortIdentity   (20-29)    
        //clockIdentity Octet[8]
         
        byte clockIdentityByteArray0=this.announceMsgOctetArray.octets[20];
        byte clockIdentityByteArray1=this.announceMsgOctetArray.octets[21];
        byte clockIdentityByteArray2=this.announceMsgOctetArray.octets[22];
        byte clockIdentityByteArray3=this.announceMsgOctetArray.octets[23];
        byte clockIdentityByteArray4=this.announceMsgOctetArray.octets[24];
        byte clockIdentityByteArray5=this.announceMsgOctetArray.octets[25];
        byte clockIdentityByteArray6=this.announceMsgOctetArray.octets[26];
        byte clockIdentityByteArray7=this.announceMsgOctetArray.octets[27]; 
        
        byte[]  clockIdentityByteArray = {clockIdentityByteArray0, clockIdentityByteArray1, clockIdentityByteArray2,clockIdentityByteArray3, clockIdentityByteArray4, clockIdentityByteArray5, clockIdentityByteArray6, clockIdentityByteArray7  };
        OctetArray clockIdentityOctetArray = new OctetArray(clockIdentityByteArray); 
        ClockIdentity clockIdentity =new ClockIdentity(clockIdentityOctetArray);
         
        //portNumber    
        
        short portNumber1 = (short) ((0x00FFL)&this.announceMsgOctetArray.octets[28]);
        short portNumber2 = (short) ((0xFF00L)&(this.announceMsgOctetArray.octets[29]<<8));  
        short portNo= (short)(portNumber2|portNumber1);   
        UInteger16 portNumber = new UInteger16((short)portNo);  
        
        PortIdentity portIdentity = new PortIdentity(clockIdentity,portNumber);
        this.messageHeader.setSourcePortIdentity(portIdentity); 
                               
                                
        // sequenceId     (30-31)
        
        short sequencIdByte1= (short) ((0x00FFL)&this.announceMsgOctetArray.octets[30]);
        short sequencIdByte2= (short)((0xFF00L)&(this.announceMsgOctetArray.octets[31]<<8));
        short sequenceIdBytes=(short)(sequencIdByte1|sequencIdByte2); 
        
        UInteger16  sequenceId = new UInteger16((short)sequenceIdBytes);
        this.messageHeader.setSequenceId(sequenceId); 
                                          
        
        //controlField
        //this.messageHeader.octets[32]=(byte)this.controlField.uinteger8Val  ;    
        byte controlFieldByte=(byte)this.announceMsgOctetArray.octets[32] ; 
        UInteger8 controlField= new UInteger8((byte)controlFieldByte);
        this.messageHeader.setControlField(controlField); 
        
        //logMessageInterval
        //this.messageHeader.octets[33]=(byte)this.logMessageInterval.integer8Val  ;   
        byte logMessageIntervalByte = (byte)this.announceMsgOctetArray.octets[33] ;
        Integer8 logMessageInterval = new Integer8(logMessageIntervalByte); 
        this.messageHeader.setLogMessageInterval(logMessageInterval); 
        
        
         
        
           // ================= msg body
        //this.announceMsg=new OctetArray((short)30);  
        
        
        // originTimestamp
        
        //nanosecondsField (UInteger32)
        
        long nanosecondFieldByte0 = (long)(0x00000000000000FFL)&this.announceMsgOctetArray.octets[34];
        long nanosecondFieldByte1 = (long)(0x000000000000FF00L)&this.announceMsgOctetArray.octets[35]<<8;
        long nanosecondFieldByte2 = (long)(0x0000000000FF0000L)&this.announceMsgOctetArray.octets[36]<<16;
        long nanosecondFieldByte3 = (long)(0x00000000FF000000L)&this.announceMsgOctetArray.octets[37]<<24; 
        long nanosecondFieldBytes = (long)(nanosecondFieldByte3|nanosecondFieldByte2|nanosecondFieldByte1|nanosecondFieldByte0) ;
        UInteger32 nanosecondField = new UInteger32(nanosecondFieldBytes);
        
        //secondsField   (UInteger48)
        
        long secondsFieldByte0= (long)(0x00000000000000FFL)&this.announceMsg.octets[38];
        long secondsFieldByte1= (long)(0x000000000000FF00L)&this.announceMsg.octets[39]<<8;
        long secondsFieldByte2= (long)(0x0000000000FF0000L)&this.announceMsg.octets[40]<<16;
        long secondsFieldByte3= (long)(0x00000000FF000000L)&this.announceMsg.octets[41]<<24;
        long secondsFieldByte4= (long)(0x000000FF00000000L)&this.announceMsg.octets[42]<<32;
        long secondsFieldByte5= (long)(0x0000FF0000000000L)&this.announceMsg.octets[43]<<40;  
        
        long secondsFieldBytes = (long)(secondsFieldByte5|secondsFieldByte4|secondsFieldByte3|secondsFieldByte2|secondsFieldByte1|secondsFieldByte0) ;
        UInteger48 secondsField = new UInteger48(secondsFieldBytes); 
        
        Timestamp timeStamp= new Timestamp(secondsField,nanosecondField);
        
        this.setOriginTimestamp(timeStamp);
        
        
        // currentUtcOffset
        
         
        short  currentUtcOffsetByte1= (short) (0x00FFL& this.announceMsg.octets[44]);
        short  currentUtcOffsetByte2= (short) (0xFF00L& this.announceMsg.octets[45]<<8);       
        short  currentUtcOffsetBytes= (short)(currentUtcOffsetByte2|currentUtcOffsetByte1);
        
        UInteger16 currentUtcOffset =new UInteger16(currentUtcOffsetBytes);  
        this.setCurrentUtcOffset(currentUtcOffset) ;
        
        
        
        // reserved1
        
        byte annonceReserved1Byte=  this.announceMsg.octets[46];   
        UInteger8  annonceReserved1= new UInteger8(annonceReserved1Byte);   
        this.setAnnonceReserved1(annonceReserved1);
                                 
        // grandmasterPriority1
        
        byte grandmasterPriority1Byte=  this.announceMsg.octets[47];   
        UInteger8  grandmasterPriority1= new UInteger8(grandmasterPriority1Byte);   
        this.setGrandmasterPriority1(grandmasterPriority1);
        
        
        
        //grandmasterClockQuality 
        
         byte clockClassByte=  this.announceMsg.octets[48];  
         ClockClass clockClass =new ClockClass(clockClassByte);
         
         byte clockAccuracyByte=  this.announceMsg.octets[49];   
         ClockAccuracy clockAccuracy = new ClockAccuracy(clockAccuracyByte);  
         
         short offsetScaledLogVarianceByte1= (short)(0x00FFL&this.announceMsg.octets[50]);
         short offsetScaledLogVarianceByte2= (short)(0xFF00L&this.announceMsg.octets[51]<<8);
         short offsetScaledLogVarianceBytes= (short)(offsetScaledLogVarianceByte2|offsetScaledLogVarianceByte1);  
         UInteger16 offsetScaledLogVariance =new UInteger16(offsetScaledLogVarianceBytes);   
         ClockQuality clockQuality =new ClockQuality(clockClass,clockAccuracy,offsetScaledLogVariance); 
         this.setGrandmasterClockQuality(clockQuality);
         
             
             
             
        // grandmasterPriority2          
        byte grandmasterPriority2Byte =  this.announceMsg.octets[52];
        UInteger8 grandmasterPriority2= new UInteger8(grandmasterPriority2Byte);  
        this.setGrandmasterPriority2(grandmasterPriority2);
        
        
        //grandMasterIdentity
           
        byte clockIDByteArray0=this.announceMsgOctetArray.octets[53];
        byte clockIDByteArray1=this.announceMsgOctetArray.octets[54];
        byte clockIDByteArray2=this.announceMsgOctetArray.octets[55];
        byte clockIDByteArray3=this.announceMsgOctetArray.octets[56];
        byte clockIDByteArray4=this.announceMsgOctetArray.octets[57];
        byte clockIDByteArray5=this.announceMsgOctetArray.octets[58];
        byte clockIDByteArray6=this.announceMsgOctetArray.octets[59];
        byte clockIDByteArray7=this.announceMsgOctetArray.octets[60]; 
        
        byte[]  clockIDByteArray = {clockIDByteArray0, clockIDByteArray1, clockIDByteArray2,clockIDByteArray3, clockIDByteArray4, clockIDByteArray5, clockIDByteArray6, clockIDByteArray7  };
        OctetArray clockIDOctetArray = new OctetArray(clockIDByteArray); 
        ClockIdentity clockID =new ClockIdentity(clockIDOctetArray);
           
        this.setGrandmasterIdentity(clockID);
                     
           
           
        // stepsRemoved.   
           
        
        byte stepsRemovedByte1 = (byte)(0x0FL&this.announceMsg.octets[61]);
        byte stepsRemovedByte2 = (byte)(0xF0L&this.announceMsg.octets[62]<<8);
        byte stepsRemovedBytes = (byte)(stepsRemovedByte2|stepsRemovedByte1) ;
        
        UInteger8 stepsRemoved = new UInteger8(stepsRemovedBytes); 
        this.setStepsRemoved(stepsRemoved);
        
                                      
        // timeSource                              
                                      
        byte  timeSourceByte = this.announceMsg.octets[63];   
        TimeSource timeSource =new TimeSource(timeSourceByte);
        this.setTimeSource(timeSource);
        
        //#]
    }
    
    /**
    Table 25: Announce message fields
    
    Bits	Octets 	Offset 	
    7	6	5	4	3	2	1	0			
    header ( 13.3)	34	0	
    originTimestamp	10	34	
    currentUtcOffset	2	44	
    reserved	1	46	
    grandmasterPriority1	1	47	
    grandmasterClockQuality 	4	48	
    grandmasterPriority2	1	52	
    grandmasterIdentity 	8	53	
    stepsRemoved 	2	61	
    timeSource  	1	63	
    */
    //## operation GetAnnounceMsgOctetArray() 
    public OctetArray GetAnnounceMsgOctetArray() {
        //#[ operation GetAnnounceMsgOctetArray() 
        // 34+30=64
        
        //this.announceMsgOctetArray=new OctetArray((short)64); 
        byte[] announceMsgByteArray ={0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0};
         
        if(this.getMessageHeader()!=null)
        {
        //transportSpecific, messageType  
        byte byte0a = (byte)(this.getMessageHeader().getTransportSpecific().getNibbleVal()<<4);   
        byte byte0b = (byte) this.getMessageHeader().getMessageType().GetMessageType()  ;   
        byte byte0= (byte) (byte0a|byte0b);   
        announceMsgByteArray[0]=byte0;
                               
        // reserved1, versionPTP  
        byte byte1a = (byte) (this.getMessageHeader().getReserved1().getNibbleVal()<<4);
        byte byte1b = this.messageHeader.getVersionPTP().getUinteger4Val()  ;
        byte byte1 = (byte) (byte1a|byte1b);  
        announceMsgByteArray[1]=byte1;
        
        
        
        // messageLength
        byte byte2=(byte)(0x00FF & this.getMessageHeader().getMessageLength().getUinteger16Val() ) ;
        announceMsgByteArray[2]=byte2;
         
        byte byte3=(byte)((this.getMessageHeader().getMessageLength().getUinteger16Val()& 0xFF00)>>8)  ;
        announceMsgByteArray[3]=byte3;
        
        //domainNumber 
        byte byte4= (byte) this.getMessageHeader().getDomainNumber().getDomain();   
        announceMsgByteArray[4]=byte4;
        
         // reserved2
        byte byte5= (byte)this.getMessageHeader().getReserved2().getUinteger8Val();   
        announceMsgByteArray[5]=byte5;
        
         //flags                    
        byte byte6= (byte)this.getMessageHeader().getFlagField().getOctets(0);   
        announceMsgByteArray[6]=byte6;  
          
        byte byte7= (byte)this.getMessageHeader().getFlagField().getOctets(1);   
        announceMsgByteArray[7]=byte7;
        
        
        // correctionField
        byte byte8= (byte)(this.getMessageHeader().getCorrectionField().getInteger64Val()&0x00000000000000FF);   
        announceMsgByteArray[8]=byte8;
        
        byte byte9= (byte)((this.getMessageHeader().getCorrectionField().getInteger64Val()>>8)&0x00000000000000FF);   
        announceMsgByteArray[9]=byte9;
        
        byte byte10= (byte)((this.getMessageHeader().getCorrectionField().getInteger64Val()>>16)&0x00000000000000FF);     
        announceMsgByteArray[10]=byte10;
        
        byte byte11= (byte)((this.getMessageHeader().getCorrectionField().getInteger64Val()>>24)&0x00000000000000FF);      
        announceMsgByteArray[11]=byte11;
        
        byte byte12= (byte)((this.getMessageHeader().getCorrectionField().getInteger64Val()>>32)&0x00000000000000FF);     
        announceMsgByteArray[12]=byte12;
        
        byte byte13= (byte)((this.getMessageHeader().getCorrectionField().getInteger64Val()>>40)&0x00000000000000FF);     
        announceMsgByteArray[13]=byte13;
        
        byte byte14= (byte)((this.getMessageHeader().getCorrectionField().getInteger64Val()>>48)&0x00000000000000FF);     
        announceMsgByteArray[14]=byte14;
        
        byte byte15= (byte)((this.getMessageHeader().getCorrectionField().getInteger64Val()>> 56)&0x00000000000000FF);      
        announceMsgByteArray[15]=byte15;
                                
                                
        //reserved3                        
        byte byte16= (byte)(this.getMessageHeader().getReserved3().getUinteger32Val()&0x000000FF);   
        announceMsgByteArray[16]=byte16;
        
        byte byte17= (byte)((this.getMessageHeader().getReserved3().getUinteger32Val()>>8)&0x000000FF) ; 
        announceMsgByteArray[17]=byte17;
        
        byte byte18= (byte)((this.getMessageHeader().getReserved3().getUinteger32Val()>>16)&0x000000FF) ;  
        announceMsgByteArray[18]=byte18;
        
        byte byte19= (byte)((this.getMessageHeader().getReserved3().getUinteger32Val()>>24)&0x000000FF) ;  
        announceMsgByteArray[19]=byte19;
        
        
        
        //sourcePortIdentity   (20-29)    
        //clockIdentity Octet[8]
        byte byte20= this.getMessageHeader().getSourcePortIdentity().getClockIdentity().getClockIdentity().getOctets(0);  
        announceMsgByteArray[20]=byte20;
        
        byte byte21= this.getMessageHeader().getSourcePortIdentity().getClockIdentity().getClockIdentity().getOctets(1);   
        announceMsgByteArray[21]=byte21;
        
        byte byte22= this.getMessageHeader().getSourcePortIdentity().getClockIdentity().getClockIdentity().getOctets(2);   
        announceMsgByteArray[22]=byte22;
        
        byte byte23= this.getMessageHeader().getSourcePortIdentity().getClockIdentity().getClockIdentity().getOctets(3);   
        announceMsgByteArray[23]=byte23;
        
        byte byte24= this.getMessageHeader().getSourcePortIdentity().getClockIdentity().getClockIdentity().getOctets(4);   
        announceMsgByteArray[24]=byte24;
        
        byte byte25= this.getMessageHeader().getSourcePortIdentity().getClockIdentity().getClockIdentity().getOctets(5);    
        announceMsgByteArray[25]=byte25;
        
        byte byte26= this.getMessageHeader().getSourcePortIdentity().getClockIdentity().getClockIdentity().getOctets(6);    
        announceMsgByteArray[26]=byte26;
        
        byte byte27= this.getMessageHeader().getSourcePortIdentity().getClockIdentity().getClockIdentity().getOctets(7);    
        announceMsgByteArray[27]=byte27;
        
        
        //portNumber    
        byte byte28= (byte)(this.getMessageHeader().getSourcePortIdentity().getPortNumber().getUinteger16Val()&0x00FF)  ;  
        announceMsgByteArray[28]=byte28;
        
        byte byte29= (byte)((this.getMessageHeader().getSourcePortIdentity().getPortNumber().getUinteger16Val()>>8)&0x00FF);    
        announceMsgByteArray[29]=byte29;
        
        // sequenceId     (30-31)
        byte byte30= (byte)(this.getMessageHeader().getSequenceId().getUinteger16Val()&0x00FF)  ;    
        announceMsgByteArray[30]=byte30;
        
        byte byte31= (byte)((this.getMessageHeader().getSequenceId().getUinteger16Val()>>8)&0x00FF) ;    
        announceMsgByteArray[31]=byte31;
        
        //controlField
        byte byte32= (byte)this.getMessageHeader().getControlField().getUinteger8Val() ;    
        announceMsgByteArray[32]=byte32;
        
        //logMessageInterval
        byte byte33= (byte)this.getMessageHeader().getLogMessageInterval().getInteger8Val() ;    
        announceMsgByteArray[33]=byte33;
        }  
        else
        System.out.println("Msg header is null!!!");
        
        
        
        
          
          // announce body body
        
        //this.announceMsg=new OctetArray((short)30);  
        
        
        // originTimestamp
        
        //nanosecondsField (UInteger32)  
        
        
        byte byte34 = (byte)(this.getOriginTimestamp().getNanosecondsField().getUinteger32Val()&0x000000FF);
        byte byte35 = (byte)((this.getOriginTimestamp().getNanosecondsField().getUinteger32Val()>>8)&0x000000FF) ;
        byte byte36 = (byte)((this.getOriginTimestamp().getNanosecondsField().getUinteger32Val()>>16)&0x000000FF);                                                                                                    
        byte byte37 = (byte)((this.getOriginTimestamp().getNanosecondsField().getUinteger32Val()>>24)&0x000000FF);  
        
        announceMsgByteArray[34]=byte34;
        announceMsgByteArray[35]=byte35;
        announceMsgByteArray[36]=byte36;
        announceMsgByteArray[37]=byte37;                                                                                                  
        
        //secondsField   (UInteger48)
        
        byte byte38 = (byte)(this.getOriginTimestamp().getSecondsField().getUinteger48Val()&0x000000FF);
        byte byte39 = (byte)((this.getOriginTimestamp().getSecondsField().getUinteger48Val()>>8)&0x000000FF) ;
        byte byte40 = (byte)((this.getOriginTimestamp().getSecondsField().getUinteger48Val()>>16)&0x000000FF) ;
        byte byte41 = (byte)((this.getOriginTimestamp().getSecondsField().getUinteger48Val()>>24)&0x000000FF) ;
        byte byte42 = (byte)((this.getOriginTimestamp().getSecondsField().getUinteger48Val()>>32)&0x000000FF) ;
        byte byte43 = (byte)((this.getOriginTimestamp().getSecondsField().getUinteger48Val()>>40)&0x000000FF) ;
        announceMsgByteArray[38]=byte38;
        announceMsgByteArray[39]=byte39;
        announceMsgByteArray[40]=byte40;
        announceMsgByteArray[41]=byte41;                                                                                                  
        announceMsgByteArray[42]=byte42;
        announceMsgByteArray[43]=byte43;
        
        
        // currentUtcOffset 
        byte byte44 = (byte)(this.getCurrentUtcOffset().getUinteger16Val()&0x00FF);
        byte byte45 = (byte)((this.getCurrentUtcOffset().getUinteger16Val()>>8)&0x00FF) ;
        announceMsgByteArray[44]=byte44;
        announceMsgByteArray[45]=byte45;
        
        // reserved1   
        byte byte46= (byte)this.getAnnonceReserved1().getUinteger8Val();
        announceMsgByteArray[46]=byte46;
        
        // grandmasterPriority1 
        byte byte47= (byte)this.getGrandmasterPriority1().getUinteger8Val();
        announceMsgByteArray[47]=byte47;
         
        //grandmasterClockQuality 
        byte byte48 =(byte)this.getGrandmasterClockQuality().getClockClass().getClockClass();  //(13,17) (4)
        byte byte49 =(byte)this.getGrandmasterClockQuality().getClockAccuracy().getClockAccuracy();   //(13,17) (4)
        byte byte50 =(byte)(this.getGrandmasterClockQuality().getOffsetScaledLogVariance().getUinteger16Val()&0x00FF);   //(13,17) (4) 
        byte byte51 =(byte)((this.getGrandmasterClockQuality().getOffsetScaledLogVariance().getUinteger16Val()>>8)&0x00FF);   //(13,17) (4) 
        
        announceMsgByteArray[48]=byte48;
        announceMsgByteArray[49]=byte49;
        announceMsgByteArray[50]=byte50;
        announceMsgByteArray[51]=byte51;                                                                                                  
        
        // grandmasterPriority2  
        byte byte52 = (byte)this.getGrandmasterPriority2().getUinteger8Val();        // (18)  (1)        
        announceMsgByteArray[52]=byte52;
        
        //grandMasterIdentity   
        byte byte53 = (byte)this.getGrandmasterIdentity().getClockIdentity().getOctets(0) ;       // (19,26)  (8)   
        byte byte54 = (byte)this.getGrandmasterIdentity().getClockIdentity().getOctets(1) ;       // (19,26)  (8)   
        byte byte55 = (byte)this.getGrandmasterIdentity().getClockIdentity().getOctets(2) ;       // (19,26)  (8)   
        byte byte56 = (byte)this.getGrandmasterIdentity().getClockIdentity().getOctets(3) ;       // (19,26)  (8)   
        byte byte57 = (byte)this.getGrandmasterIdentity().getClockIdentity().getOctets(4) ;       // (19,26)  (8)   
        byte byte58 = (byte)this.getGrandmasterIdentity().getClockIdentity().getOctets(5) ;       // (19,26)  (8)   
        byte byte59 = (byte)this.getGrandmasterIdentity().getClockIdentity().getOctets(6) ;       // (19,26)  (8)   
        byte byte60 = (byte)this.getGrandmasterIdentity().getClockIdentity().getOctets(7) ;       // (19,26)  (8)   
        announceMsgByteArray[53]=byte53;
        announceMsgByteArray[54]=byte54;
        announceMsgByteArray[55]=byte55;
        announceMsgByteArray[56]=byte56;                                                                                                  
        announceMsgByteArray[57]=byte57;
        announceMsgByteArray[58]=byte58;
        announceMsgByteArray[59]=byte59;
        announceMsgByteArray[60]=byte60;                                                                                                  
           
           
           
           
        // stepsRemoved.   
        byte byte61 = (byte)(this.getStepsRemoved().getUinteger8Val()&0x00FF) ;  // (27,28)       (2)  
        byte byte62 = (byte)((this.getStepsRemoved().getUinteger8Val()>>8)&0x00FF)  ;     // (27,28)       (2)   
        announceMsgByteArray[61]=byte61;
        announceMsgByteArray[63]=byte62;
        // timeSource                              
                                      
        byte byte63 = (byte) this.getTimeSource().getTimeSource();           // (29)              (1)
        announceMsgByteArray[63]=byte63;
                   
        this.announceMsgOctetArray=new OctetArray(announceMsgByteArray); 
        return this.announceMsgOctetArray;
        //#]
    }
    
    //## operation SetAnnouncementMsgItems(OctetArray) 
    public void SetAnnouncementMsgItems(final OctetArray announceMsgOctetArray) {
        //#[ operation SetAnnouncementMsgItems(OctetArray) 
        // 34+30=44
        
        //this.syncMsg=new OctetArray((short)44);   
        
        this.announceMsgOctetArray = announceMsgOctetArray;// octetArray(44)  
        
        this.messageHeader = new MessageHeader();
              
        //this.messageHeader.octets[0]= (byte)((byte)(this.transportSpecific.nibbleVal<<4)|this.messageType.messageType)  ; 
        //messageType 
        byte messageTypeByte =(byte)(0x0FL&this.announceMsgOctetArray.octets[0]);  
        
        MessageType messageType=  new MessageType((byte)messageTypeByte) ;
        this.messageHeader.setMessageType(messageType);                                      //
               
        // transport Specific       
        byte transportSpecificByte=(byte)((byte)(0xFL)&(this.announceMsgOctetArray.octets[0]>>4)); 
        Nibble transportSpecific =new Nibble((byte)transportSpecificByte);
        this.messageHeader.setTransportSpecific(transportSpecific);
        
                    
        
        // reserved1              
        //this.messageHeader.octets[1]=(byte)((byte)(this.reserved1.nibbleVal<<4)|this.versionPTP.uinteger4Val)  ;  
        byte versionPTPByte= (byte)(0x0FL&this.announceMsgOctetArray.octets[1]);  
        UInteger4  versionPTP= new UInteger4((byte)versionPTPByte);
        this.messageHeader.setVersionPTP(versionPTP );
        
        // versionPTP 
        byte reserved1Byte=(byte)(0x0FL&this.announceMsgOctetArray.octets[1]>>4);  
        Nibble  reserved1= new Nibble((byte)reserved1Byte);
        this.messageHeader.setReserved1(reserved1);
        
        
        
        // messageLength
        //this.messageHeader.octets[2]= (byte)this.messageLength.uinteger16Val ;  
        //this.messageHeader.octets[3]= (byte)((byte)this.messageLength.uinteger16Val>>8) ; 
        short messageLengthByte1 = (short) ((0x00FFL)&this.announceMsgOctetArray.octets[2]);
        short messageLengthByte2 = (short) ((0xFF00L)&(this.announceMsgOctetArray.octets[3]<<8));   
        short messageLengthBytes= (short)(messageLengthByte1|messageLengthByte2);   
        PTPPrimitivityDataTypes.UInteger16  messageLength=  new PTPPrimitivityDataTypes.UInteger16((short)messageLengthBytes);
        this.messageHeader.setMessageLength(messageLength); 
         
        //domainNumber 
        //this.messageHeader.octets[4]= this.domainNumber.domain ; 
        byte domainNumberBye = (byte)((0x0FL)&this.announceMsgOctetArray.octets[4]);   
         //   public void setDomainNumber(Domain p_domainNumber) {
        PTPEntities.Domain domainNumber = new PTPEntities.Domain((byte)domainNumberBye);
        this.messageHeader.setDomainNumber(domainNumber); 
        
         // reserved2
        //this.messageHeader.octets[5]= (byte)this.reserved2.uinteger8Val  ; 
        UInteger8 reserved2= new UInteger8((byte)this.announceMsgOctetArray.octets[5]) ;
        this.messageHeader.setReserved2(reserved2);
                            
         //flags                    
        byte  flagFieldByteArray1= this.announceMsgOctetArray.octets[6];   
        byte  flagFieldByteArray2= this.announceMsgOctetArray.octets[7];
        byte[]  flagFieldByteArray ={flagFieldByteArray1,flagFieldByteArray2 };  
        
        OctetArray flagFieldOctetArray =    new OctetArray(flagFieldByteArray);   
        this.messageHeader.setFlagField(flagFieldOctetArray); 
        
        
        // correctionField
        long filedByte0 = (0x00000000000000FFL&this.announceMsgOctetArray.octets[8]);
        long filedByte1 = (0x000000000000FF00L&(this.announceMsgOctetArray.octets[9]<<8));    
        long filedByte2 = (0x0000000000FF0000L&(this.announceMsgOctetArray.octets[10]<<16)); 
        long filedByte3 = (0x00000000FF000000L&(this.announceMsgOctetArray.octets[11]<<24)); 
        long filedByte4 = (0x000000FF00000000L&(this.announceMsgOctetArray.octets[12]<<32)); 
        long filedByte5 = (0x0000FF0000000000L&(this.announceMsgOctetArray.octets[13]<<40)); 
        long filedByte6 = (0x00FF000000000000L&(this.announceMsgOctetArray.octets[14]<<48)); 
        long filedByte7 = (0xFF00000000000000L&(this.announceMsgOctetArray.octets[15]<<56));   
        long correctionFieldBytes=(long)(filedByte0|filedByte1|filedByte2|filedByte3|filedByte4|filedByte5|filedByte6|filedByte7) ;
        Integer64 correctionField = new Integer64((long)correctionFieldBytes);
        this.messageHeader.setCorrectionField(correctionField); 
                           
                                
        //reserved3                        
        
        int reserved3Byte0=  (int)(0x000000FFL& this.announceMsgOctetArray.octets[16]);
        int reserved3Byte1=  (int)(0x0000FF00L& this.announceMsgOctetArray.octets[17]<<8);
        int reserved3Byte2=  (int)(0x00FF0000L& this.announceMsgOctetArray.octets[18]<<16);
        int reserved3Byte3=  (int)(0xFF000000L& this.announceMsgOctetArray.octets[19]<<24);  
        int reserved3Bytes=  (int)(reserved3Byte0|reserved3Byte1|reserved3Byte2|reserved3Byte3)   ;  
        UInteger32 reserved3   = new UInteger32((int)reserved3Bytes);
        this.messageHeader.setReserved3(reserved3); 
        
        
        //sourcePortIdentity   (20-29)    
        //clockIdentity Octet[8]
        byte clockIdentityByteArray0=this.announceMsgOctetArray.octets[20];
        byte clockIdentityByteArray1=this.announceMsgOctetArray.octets[21];
        byte clockIdentityByteArray2=this.announceMsgOctetArray.octets[22];
        byte clockIdentityByteArray3=this.announceMsgOctetArray.octets[23];
        byte clockIdentityByteArray4=this.announceMsgOctetArray.octets[24];
        byte clockIdentityByteArray5=this.announceMsgOctetArray.octets[25];
        byte clockIdentityByteArray6=this.announceMsgOctetArray.octets[26];
        byte clockIdentityByteArray7=this.announceMsgOctetArray.octets[27]; 
        
        byte[]  clockIdentityByteArray = {clockIdentityByteArray0, clockIdentityByteArray1, clockIdentityByteArray2,clockIdentityByteArray3, clockIdentityByteArray4, clockIdentityByteArray5, clockIdentityByteArray6, clockIdentityByteArray7  };
        OctetArray clockIdentityOctetArray = new OctetArray(clockIdentityByteArray); 
        ClockIdentity clockIdentity =new ClockIdentity(clockIdentityOctetArray);
         
        
         
        //portNumber    
        
        short portNumber1 = (short) ((0x00FFL)&this.announceMsgOctetArray.octets[28]);
        short portNumber2 = (short) ((0xFF00L)&(this.announceMsgOctetArray.octets[29]<<8));  
        short portNo= (short)(portNumber2|portNumber1);   
        UInteger16 portNumber = new UInteger16((short)portNo);  
        
        PortIdentity portIdentity = new PortIdentity(clockIdentity,portNumber);
        this.messageHeader.setSourcePortIdentity(portIdentity); 
                               
                                
        // sequenceId     (30-31)
        
        short sequencIdByte1= (short) ((0x00FFL)&this.announceMsgOctetArray.octets[30]);
        short sequencIdByte2= (short)((0xFF00L)&(this.announceMsgOctetArray.octets[31]<<8));
        short sequenceIdBytes=(short)(sequencIdByte1|sequencIdByte2); 
        
        UInteger16  sequenceId = new UInteger16((short)sequenceIdBytes);
        this.messageHeader.setSequenceId(sequenceId); 
                                          
        
        //controlField
        byte controlFieldByte=(byte)this.announceMsgOctetArray.octets[32] ; 
        UInteger8 controlField= new UInteger8((byte)controlFieldByte);
        this.messageHeader.setControlField(controlField); 
        
        //logMessageInterval
        byte logMessageIntervalByte = (byte)this.announceMsgOctetArray.octets[33] ;
        Integer8 logMessageInterval = new Integer8(logMessageIntervalByte); 
        this.messageHeader.setLogMessageInterval(logMessageInterval); 
        
        
         
        
           // ================= msg body
        //this.announceMsg=new OctetArray((short)30);  
        
        
        // originTimestamp
        
        //nanosecondsField (UInteger32)
        long nanosecondFieldByte0 = (long)(0x00000000000000FFL)&this.announceMsgOctetArray.octets[34];
        long nanosecondFieldByte1 = (long)(0x000000000000FF00L)&this.announceMsgOctetArray.octets[35]<<8;
        long nanosecondFieldByte2 = (long)(0x0000000000FF0000L)&this.announceMsgOctetArray.octets[36]<<16;
        long nanosecondFieldByte3 = (long)(0x00000000FF000000L)&this.announceMsgOctetArray.octets[37]<<24; 
        long nanosecondFieldBytes = (long)(nanosecondFieldByte3|nanosecondFieldByte2|nanosecondFieldByte1|nanosecondFieldByte0) ;
        UInteger32 nanosecondField = new UInteger32(nanosecondFieldBytes);
        
        //secondsField   (UInteger48)
        
        long secondsFieldByte0= (long)(0x00000000000000FFL)&this.announceMsgOctetArray.octets[38];
        long secondsFieldByte1= (long)(0x000000000000FF00L)&this.announceMsgOctetArray.octets[39]<<8;
        long secondsFieldByte2= (long)(0x0000000000FF0000L)&this.announceMsgOctetArray.octets[40]<<16;
        long secondsFieldByte3= (long)(0x00000000FF000000L)&this.announceMsgOctetArray.octets[41]<<24;
        long secondsFieldByte4= (long)(0x000000FF00000000L)&this.announceMsgOctetArray.octets[42]<<32;
        long secondsFieldByte5= (long)(0x0000FF0000000000L)&this.announceMsgOctetArray.octets[43]<<40;  
        
        long secondsFieldBytes = (long)(secondsFieldByte5|secondsFieldByte4|secondsFieldByte3|secondsFieldByte2|secondsFieldByte1|secondsFieldByte0) ;
        UInteger48 secondsField = new UInteger48(secondsFieldBytes); 
        
        Timestamp timeStamp= new Timestamp(secondsField,nanosecondField);
        
        this.setOriginTimestamp(timeStamp);
        
        
        // currentUtcOffset
         
        short  currentUtcOffsetByte1= (short) (0x00FFL& this.announceMsgOctetArray.octets[44]);
        short  currentUtcOffsetByte2= (short) (0xFF00L& this.announceMsgOctetArray.octets[45]<<8);       
        short  currentUtcOffsetBytes= (short)(currentUtcOffsetByte2|currentUtcOffsetByte1);
        
        UInteger16 currentUtcOffset =new UInteger16(currentUtcOffsetBytes);  
        this.setCurrentUtcOffset(currentUtcOffset) ;
        
        
        
        // reserved1
        
        byte annonceReserved1Byte=  this.announceMsgOctetArray.octets[46];   
        UInteger8  annonceReserved1= new UInteger8(annonceReserved1Byte);   
        this.setAnnonceReserved1(annonceReserved1);
                                 
        // grandmasterPriority1
        
        byte grandmasterPriority1Byte=  this.announceMsgOctetArray.octets[47];   
        UInteger8  grandmasterPriority1= new UInteger8(grandmasterPriority1Byte);   
        this.setGrandmasterPriority1(grandmasterPriority1);
        
        
        
        //grandmasterClockQuality 
        
         byte clockClassByte=  this.announceMsgOctetArray.octets[48];  
         ClockClass clockClass =new ClockClass(clockClassByte);
         
         byte clockAccuracyByte=  this.announceMsgOctetArray.octets[49];   
         ClockAccuracy clockAccuracy = new ClockAccuracy(clockAccuracyByte);  
         
         short offsetScaledLogVarianceByte1= (short)(0x00FFL&this.announceMsgOctetArray.octets[50]);
         short offsetScaledLogVarianceByte2= (short)(0xFF00L&this.announceMsgOctetArray.octets[51]<<8);
         short offsetScaledLogVarianceBytes= (short)(offsetScaledLogVarianceByte2|offsetScaledLogVarianceByte1);  
         UInteger16 offsetScaledLogVariance =new UInteger16(offsetScaledLogVarianceBytes);   
         ClockQuality clockQuality =new ClockQuality(clockClass,clockAccuracy,offsetScaledLogVariance); 
         this.setGrandmasterClockQuality(clockQuality);
         
             
             
             
        // grandmasterPriority2          
        //this.announceMsg.octets[52]= (byte)this.grandmasterPriority2.uinteger8Val;        // (18)  (1)     
        byte grandmasterPriority2Byte =  this.announceMsgOctetArray.octets[52];
        UInteger8 grandmasterPriority2= new UInteger8(grandmasterPriority2Byte);  
        this.setGrandmasterPriority2(grandmasterPriority2);
        
        
        //grandMasterIdentity
        byte clockIDByteArray0=this.announceMsgOctetArray.octets[53];
        byte clockIDByteArray1=this.announceMsgOctetArray.octets[54];
        byte clockIDByteArray2=this.announceMsgOctetArray.octets[55];
        byte clockIDByteArray3=this.announceMsgOctetArray.octets[56];
        byte clockIDByteArray4=this.announceMsgOctetArray.octets[57];
        byte clockIDByteArray5=this.announceMsgOctetArray.octets[58];
        byte clockIDByteArray6=this.announceMsgOctetArray.octets[59];
        byte clockIDByteArray7=this.announceMsgOctetArray.octets[60]; 
        
        byte[]  clockIDByteArray = {clockIDByteArray0, clockIDByteArray1, clockIDByteArray2,clockIDByteArray3, clockIDByteArray4, clockIDByteArray5, clockIDByteArray6, clockIDByteArray7  };
        OctetArray clockIDOctetArray = new OctetArray(clockIDByteArray); 
        ClockIdentity clockID =new ClockIdentity(clockIDOctetArray);
           
        this.setGrandmasterIdentity(clockID);
                     
           
           
        // stepsRemoved.   
           
        
        
        byte stepsRemovedByte1 = (byte)(0x0FL&this.announceMsgOctetArray.octets[61]);
        byte stepsRemovedByte2 = (byte)(0xF0L&this.announceMsgOctetArray.octets[62]<<8);
        byte stepsRemovedBytes = (byte)(stepsRemovedByte2|stepsRemovedByte1) ;
        
        UInteger8 stepsRemoved = new UInteger8(stepsRemovedBytes); 
        this.setStepsRemoved(stepsRemoved);
        
                                      
        // timeSource                              
                                      
        byte  timeSourceByte = this.announceMsgOctetArray.octets[63];   
        TimeSource timeSource =new TimeSource(timeSourceByte);
        this.setTimeSource(timeSource);
        
        //#]
    }
    
    //## auto_generated 
    public UInteger8 getAnnonceReserved1() {
        return annonceReserved1;
    }
    
    //## auto_generated 
    public void setAnnonceReserved1(UInteger8 p_annonceReserved1) {
        annonceReserved1 = p_annonceReserved1;
    }
    
    //## auto_generated 
    public OctetArray getAnnounceMsg() {
        return announceMsg;
    }
    
    //## auto_generated 
    public void setAnnounceMsg(OctetArray p_announceMsg) {
        announceMsg = p_announceMsg;
    }
    
    //## auto_generated 
    public OctetArray getAnnounceMsgOctetArray() {
        return announceMsgOctetArray;
    }
    
    //## auto_generated 
    public void setAnnounceMsgOctetArray(OctetArray p_announceMsgOctetArray) {
        announceMsgOctetArray = p_announceMsgOctetArray;
    }
    
    //## auto_generated 
    public UInteger16 getCurrentUtcOffset() {
        return currentUtcOffset;
    }
    
    //## auto_generated 
    public void setCurrentUtcOffset(UInteger16 p_currentUtcOffset) {
        currentUtcOffset = p_currentUtcOffset;
    }
    
    //## auto_generated 
    public ClockQuality getGrandmasterClockQuality() {
        return grandmasterClockQuality;
    }
    
    //## auto_generated 
    public void setGrandmasterClockQuality(ClockQuality p_grandmasterClockQuality) {
        grandmasterClockQuality = p_grandmasterClockQuality;
    }
    
    //## auto_generated 
    public ClockIdentity getGrandmasterIdentity() {
        return grandmasterIdentity;
    }
    
    //## auto_generated 
    public void setGrandmasterIdentity(ClockIdentity p_grandmasterIdentity) {
        grandmasterIdentity = p_grandmasterIdentity;
    }
    
    //## auto_generated 
    public UInteger8 getGrandmasterPriority1() {
        return grandmasterPriority1;
    }
    
    //## auto_generated 
    public void setGrandmasterPriority1(UInteger8 p_grandmasterPriority1) {
        grandmasterPriority1 = p_grandmasterPriority1;
    }
    
    //## auto_generated 
    public UInteger8 getGrandmasterPriority2() {
        return grandmasterPriority2;
    }
    
    //## auto_generated 
    public void setGrandmasterPriority2(UInteger8 p_grandmasterPriority2) {
        grandmasterPriority2 = p_grandmasterPriority2;
    }
    
    //## auto_generated 
    public Timestamp getOriginTimestamp() {
        return originTimestamp;
    }
    
    //## auto_generated 
    public void setOriginTimestamp(Timestamp p_originTimestamp) {
        originTimestamp = p_originTimestamp;
    }
    
    //## auto_generated 
    public static short getSizeOfMsg() {
        return sizeOfMsg;
    }
    
    //## auto_generated 
    public static void setSizeOfMsg(short p_sizeOfMsg) {
        sizeOfMsg = p_sizeOfMsg;
    }
    
    //## auto_generated 
    public UInteger8 getStepsRemoved() {
        return stepsRemoved;
    }
    
    //## auto_generated 
    public void setStepsRemoved(UInteger8 p_stepsRemoved) {
        stepsRemoved = p_stepsRemoved;
    }
    
    //## auto_generated 
    public TimeSource getTimeSource() {
        return timeSource;
    }
    
    //## auto_generated 
    public void setTimeSource(TimeSource p_timeSource) {
        timeSource = p_timeSource;
    }
    
}
/*********************************************************************
	File Path	: DelayReqRespSlave/SlaveClock/PTPMessages/Announce.java
*********************************************************************/

