/*********************************************************************
	Rhapsody	: 7.1
	Login		: ysong_a
	Component	: ObjectModel
	Configuration 	: ObjectModel
	Model Element	: PeerToPeerDefaultPTPprofile
//!	Generated Date	: Fri, 1, Aug 2008 
	File Path	: ObjectModel/ObjectModel/PTPProfiles/PeerToPeerDefaultPTPprofile.java
*********************************************************************/

package PTPProfiles;

//## auto_generated
import java.util.*;
//## attribute domain 
import PTPEntities.Domain;
//## auto_generated
import com.ilogix.rhapsody.oxf.*;
//## attribute pathDelayMeasurementMechanism 
import PTPEnumTypes.DelayMechanism;
//## attribute logAnnounceInterval 
import PTPDerivedDataTypes.TimeInterval;
//## attribute slaveOnly 
import PTPPrimitivityDataTypes._Boolean;
//## auto_generated
import com.ilogix.rhapsody.oxf.states.*;
//## attribute priority1 
import PTPPrimitivityDataTypes.UInteger8;
//## attribute frequencyAccuracy 
import PTPPrimitivityDataTypes.Integer32;
//## auto_generated
import com.ilogix.rhapsody.oxf.services.*;
//## auto_generated
import com.ilogix.rhapsody.oxf.timeouts.*;

//----------------------------------------------------------------------------
// PTPProfiles/PeerToPeerDefaultPTPprofile.java                                                                  
//----------------------------------------------------------------------------

//## package PTPProfiles 


/**
PTP Profile
Default PTP profile for use with the delay request-response mechanism.
Version 1.0
Profile identifier: 00-1B-19-00-02-00

This profile is specified by the Precise Networked Clock Synchronization Working Group of the IM/ST Committee.
*/
//## class PeerToPeerDefaultPTPprofile 
public class PeerToPeerDefaultPTPprofile extends PTPProfile {
    
    /**
    The default initialization value shall be 3. The configurable range shall be in the range 2 to 10.
    */
    protected int announceReceiptTimeout = 3;		//## attribute announceReceiptTimeout 
    
    protected Domain domain;		//## attribute domain 
    
    /**
    Every grandmaster clock shall maintain a frequency deviating no more than 0.01% from the SI second.
    */
    protected Integer32 frequencyAccuracy;		//## attribute frequencyAccuracy 
    
    protected Integer32 frequencyAdjustmentRange;		//## attribute frequencyAdjustmentRange 
    
    /**
    The default initialization value shall be 0. The configurable range shall be -1 to +1
    */
    protected TimeInterval logAnnounceInterval;		//## attribute logAnnounceInterval 
    
    /**
    The default initialization value shall be 0. The configurable range shall be 0 to 5.
    */
    protected TimeInterval logMinPdelayReqInterval;		//## attribute logMinPdelayReqInterval 
    
    protected DelayMechanism pathDelayMeasurementMechanism;		//## attribute pathDelayMeasurementMechanism 
    
    protected Domain primaryDomain;		//## attribute primaryDomain 
    
    /**
    The default initialization value shall be 128
    */
    protected UInteger8 priority1;		//## attribute priority1 
    
    /**
    priority2
    */
    protected UInteger8 priority2;		//## attribute priority2 
    
    /**
    If this parameter is configurable the default value shall be FALSE
    */
    protected _Boolean slaveOnly;		//## attribute slaveOnly 
    
    /**
    The default initialization value shall be 1.0 seconds
    */
    protected TimeInterval t;		//## attribute t 
    
    
    // Constructors
    
    //## operation PeerToPeerDefaultPTPprofile() 
    public  PeerToPeerDefaultPTPprofile() {
        //#[ operation PeerToPeerDefaultPTPprofile() 
        //#]
    }
    
    //## auto_generated 
    public int getAnnounceReceiptTimeout() {
        return announceReceiptTimeout;
    }
    
    //## auto_generated 
    public void setAnnounceReceiptTimeout(int p_announceReceiptTimeout) {
        announceReceiptTimeout = p_announceReceiptTimeout;
    }
    
    //## auto_generated 
    public Domain getDomain() {
        return domain;
    }
    
    //## auto_generated 
    public void setDomain(Domain p_domain) {
        domain = p_domain;
    }
    
    /**
    Every grandmaster clock shall maintain a frequency deviating no more than 0.01% from the SI second.
    */
    //## auto_generated 
    public Integer32 getFrequencyAccuracy() {
        return frequencyAccuracy;
    }
    
    //## auto_generated 
    public void setFrequencyAccuracy(Integer32 p_frequencyAccuracy) {
        frequencyAccuracy = p_frequencyAccuracy;
    }
    
    //## auto_generated 
    public Integer32 getFrequencyAdjustmentRange() {
        return frequencyAdjustmentRange;
    }
    
    //## auto_generated 
    public void setFrequencyAdjustmentRange(Integer32 p_frequencyAdjustmentRange) {
        frequencyAdjustmentRange = p_frequencyAdjustmentRange;
    }
    
    /**
    The default initialization value shall be 0. The configurable range shall be -1 to +1
    */
    //## auto_generated 
    public TimeInterval getLogAnnounceInterval() {
        return logAnnounceInterval;
    }
    
    //## auto_generated 
    public void setLogAnnounceInterval(TimeInterval p_logAnnounceInterval) {
        logAnnounceInterval = p_logAnnounceInterval;
    }
    
    /**
    The default initialization value shall be 0. The configurable range shall be 0 to 5.
    */
    //## auto_generated 
    public TimeInterval getLogMinPdelayReqInterval() {
        return logMinPdelayReqInterval;
    }
    
    //## auto_generated 
    public void setLogMinPdelayReqInterval(TimeInterval p_logMinPdelayReqInterval) {
        logMinPdelayReqInterval = p_logMinPdelayReqInterval;
    }
    
    //## auto_generated 
    public DelayMechanism getPathDelayMeasurementMechanism() {
        return pathDelayMeasurementMechanism;
    }
    
    //## auto_generated 
    public void setPathDelayMeasurementMechanism(DelayMechanism p_pathDelayMeasurementMechanism) {
        pathDelayMeasurementMechanism = p_pathDelayMeasurementMechanism;
    }
    
    //## auto_generated 
    public Domain getPrimaryDomain() {
        return primaryDomain;
    }
    
    //## auto_generated 
    public void setPrimaryDomain(Domain p_primaryDomain) {
        primaryDomain = p_primaryDomain;
    }
    
    /**
    The default initialization value shall be 128
    */
    //## auto_generated 
    public UInteger8 getPriority1() {
        return priority1;
    }
    
    //## auto_generated 
    public void setPriority1(UInteger8 p_priority1) {
        priority1 = p_priority1;
    }
    
    /**
    priority2
    */
    //## auto_generated 
    public UInteger8 getPriority2() {
        return priority2;
    }
    
    //## auto_generated 
    public void setPriority2(UInteger8 p_priority2) {
        priority2 = p_priority2;
    }
    
    /**
    If this parameter is configurable the default value shall be FALSE
    */
    //## auto_generated 
    public _Boolean getSlaveOnly() {
        return slaveOnly;
    }
    
    //## auto_generated 
    public void setSlaveOnly(_Boolean p_slaveOnly) {
        slaveOnly = p_slaveOnly;
    }
    
    /**
    The default initialization value shall be 1.0 seconds
    */
    //## auto_generated 
    public TimeInterval getT() {
        return t;
    }
    
    //## auto_generated 
    public void setT(TimeInterval p_t) {
        t = p_t;
    }
    
}
/*********************************************************************
	File Path	: ObjectModel/ObjectModel/PTPProfiles/PeerToPeerDefaultPTPprofile.java
*********************************************************************/

